extends Area2D
class_name AttackModel
func attack():
	player().show_action("伤害")
	match player().get_dir():
		0:
			player().play_animation("up_attack")
		1:
			player().play_animation("down_attack")
		2:
			player().play_animation("left_right_attack")
		3:
			player().play_animation("left_right_attack")
	
#判断单位是否再攻击范围内
func is_unit_instance_in_attack_area(instance:Node):
		if instance is PhysicsBody2D:
			return instance in get_overlapping_bodies()
		if instance is Area2D:
			return instance in get_overlapping_areas()
func _ready() -> void:
	player().animation.frame_changed.connect(frame_changed)
	pass
var attack_frames=2
func player()->Unit:
	return get_parent().get_parent()
func frame_changed():
	if player().animation.animation in [&"up_attack",&"down_attack",&"left_right_attack"] and player().animation.frame==attack_frames:
		use_attack_damage()

#在固定帧使用攻击
func use_attack_damage():
	print("使用攻击")
	for i in %attack_area.get_overlapping_bodies():
		print(i)
		if i is Unit and i!=player():
			i.attacked(player().get_unit_id(),player().get_atk())
#if animation.animation in [&"up_attack",&"down_attack",&"left_right_attack"] and not animation.is_playing():
		#return true
	#else:
		#return false
func is_attack_finished():
	if player().animation.animation in [&"up_attack",&"down_attack",&"left_right_attack"] and not player().animation.is_playing():
		return true
	else:
		return false
func is_attacking():
	return player().animation.animation in [&"up_attack",&"down_attack",&"left_right_attack"] and  player().animation.is_playing()
#攻击复位
func attack_reset():
	
	
	pass
